Attribute VB_Name = "Module1"
Public Const TO_DEGREES = 57.2957795130823
Public Const TO_RADIANS = 1.74532925199433E-02
Public Const PI = 3.14159265358979
Public Const BK = 6

Public wmargin As Long  ' assume equal width margins, twips (side margins)
Public hmargin As Long  '   "                               (top/bottom margins)

Public Pheight As Long   ' total height in twips of the page
Public Pwidth As Long    ' total width in twips of the page

Public TwipToMeter As Double  ' ratio bewteen a logical twip unit and map meter

Public Maxdim As Long ' maximum number of twips (either horizontal or vertival)

Type POINTAPI
 X As Long
 Y As Long
End Type

Public Type Size
        cx As Long
        cy As Long
End Type

Public Type Point2DLong
 X As Long
 Y As Long
End Type

Public Type Point3D
 X As Double
 Y As Double
 z As Double
End Type

Public Type Point2D
 X As Double
 Y As Double
End Type

Public Type Tree
 plot As Long
 Pos As Point3D
 z_dtm As Double
 spec As Long
 state As Long
 Foto_h As Double
 Lidar_h As Double
 Dcrm_Foto As Double
 Dcrm_Lidar As Double
 Dcrm_RMSE As Double
 Dist_Cent As Double
 Bussol As Double
 inside As Long
 cf As Double
 pw As Double
 cont As Double
 Num As Long
 col As Long
 row As Long
 Label As Boolean
End Type

Public Type NeighborTree
  Num As Long
  Pos As Point3D
  spec As Long
  dist As Double
  azim As Double
End Type

Public Neighbor() As NeighborTree
Public Trees() As Tree

Type Plot_info
 Num As Long
 X As Double
 Y As Double
 Vol_Lidar As Double
 G As Double
 N As Double
 H As Double
 D As Double
End Type

Type height_model
 ncols As Double
 nrows As Double
 xllcorner As Double
 yllcorner As Double
 CellSize As Double
 nodata_value As Double
 filepath As String * 80
End Type

Public Zmodel As height_model
Public ZfXY() As Single



Public triangle(0 To 2) As POINTAPI
Public rectang(0 To 3) As POINTAPI
Public cross(0 To 3) As POINTAPI
Public elliple(0 To 1) As POINTAPI

Public lpPoint As POINTAPI
Public lpSize As Size
Public lpstring As String * 6
Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal ncount As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Public Declare Function rectangle Lib "gdi32" Alias "Rectangle" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpstring As String, ByVal ncount As Long) As Long
Public Declare Function GetWindowExtEx Lib "gdi32" (ByVal hdc As Long, lpSize As Size) As Long
Public Declare Function MYFUNC_ATAN2 Lib "c:\data\pascaldll.dll" (ByVal v1 As Double, ByVal v1 As Double) As Double



Public Sub DrawLines(apu1 As Long, corn() As Point2DLong, hmargin As Long, wmargin As Long, ymax As Long)

Printer.DrawStyle = 0
Printer.DrawWidth = 5
apu = MoveToEx(ByVal apu1, ByVal CLng(wmargin + corn(1).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(1).Y / Printer.TwipsPerPixelY)), lpPoint)
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(3).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(3).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(6).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(6).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(4).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(4).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(7).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(7).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(9).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(9).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(12).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(12).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(10).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(10).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(1).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(1).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(2).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(2).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(11).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(11).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(12).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(12).Y / Printer.TwipsPerPixelY)))
apu = LineTo(ByVal apu1, ByVal CLng(wmargin + corn(3).X / Printer.TwipsPerPixelX), ByVal CLng(ymax - (hmargin + corn(3).Y / Printer.TwipsPerPixelY)))

End Sub
Public Sub FindNeighbors(l As Long, m As Long, Ntau() As Long)
Rem Find neighbors for tree l
Dim i As Long, distA As Double
distA = 8
m = 0
  For i = 1 To UBound(Trees())
    If i = l Then GoTo nexttree
     If Abs(Trees(i).Pos.X - Trees(l).Pos.X) < distA And Abs(Trees(i).Pos.Y - Trees(l).Pos.Y) < distA Then
      m = m + 1
      Ntau(m) = i
     End If
nexttree: Next i
End Sub

Public Sub DrawNumber(apu1 As Long, M_in As Long, l As Long, orix As Long, oriY As Long, hmargin As Long, wmargin As Long, ymax As Long)
Dim apustring As String * 60

Printer.FontSize = 12
Printer.FontBold = True
apustring = CStr("sn:o " & M_in)
apu = TextOut(ByVal apu1, ByVal wmargin + orix / Printer.TwipsPerPixelX + 40, ByVal ymax - (hmargin + oriY / Printer.TwipsPerPixelY - 40), ByVal apustring, ByVal 30)

If Trees(l).inside = 1 Then
 apustring = "Plot: " & Trees(l).plot & "  Dist: " & Format$(Trees(l).Dist_Cent, "0.0") & " m   Azim: " & Format$(Trees(l).Bussol, "0.0") & " degr"
Else
 apustring = CStr("OUTSIDE PLOT")
End If
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal wmargin + orix / Printer.TwipsPerPixelX + 450, ByVal ymax - (hmargin + oriY / Printer.TwipsPerPixelY - 40), ByVal apustring, ByVal ncount)

If Trees(l).Num > 999 Then Printer.FontSize = 120
If Trees(l).Num < 1000 Then Printer.FontSize = 140
Printer.FontBold = True
apustring = CStr(Trees(l).Num)
If Trees(l).inside = 1 Then
 Printer.ForeColor = RGB(0, 0, 0)
Else
 Printer.ForeColor = RGB(100, 100, 100)
End If
addmarg = 0
If Trees(l).Num < 10 Then addmarg = 300
If Trees(l).Num > 9 And Trees(l).Num < 100 Then addmarg = 150

apu = TextOut(ByVal apu1, ByVal wmargin + addmarg + orix / Printer.TwipsPerPixelX + (Printer.ScaleWidth / Printer.TwipsPerPixelX) * 0.03, ByVal ymax - (hmargin + oriY / Printer.TwipsPerPixelY - (Printer.ScaleHeight / Printer.TwipsPerPixelY) * 0.03), ByVal apustring, ByVal 30)
 Printer.ForeColor = RGB(0, 0, 0)
End Sub

Public Sub DrawNeighbors(l As Long, k As Long, Ntau() As Long, apu1 As Long, wmargin As Long, hmargin As Long, orix As Long, oriY As Long, ymax As Long)

Dim i As Long, dx As Double, dy As Double, tau As Double
Dim apustring As String * 60
For i = 1 To k
 dx = Trees(Ntau(i)).Pos.X - Trees(l).Pos.X
 dy = Trees(Ntau(i)).Pos.Y - Trees(l).Pos.Y
 tau = MYFUNC_ATAN2(dy, dx)
 Rem Now tau is angle from x-axis, bussol will have an offset of BK (6.5 degrees)
 If tau <= 0 Then
  Bussol = 90 + (-tau) * TO_DEGREES
 End If
 If tau > 0 And tau <= PI / 2 Then
  Bussol = 90 - tau * TO_DEGREES
 End If
 If tau >= PI / 2 Then
  Bussol = ((tau - (5 * PI / 2)) * -360 / (2 * PI))
 End If
 Rem If the Bussol-reading is within 0 to BK (positive BK) then we must do a trick
 If Bussol > 0 And Bussol < BK Then
  Bussol = Bussol + (360 - BK)
 Else
  Bussol = Bussol - BK
 End If
 
 rho = Sqr(dx ^ 2 + dy ^ 2)
 Ltm = 55
 rectang(0).X = wmargin + 500 + orix / Printer.TwipsPerPixelX + Ltm * dx - Trees(Ntau(i)).Foto_h / 2
 rectang(0).Y = ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX + Ltm * dy + Trees(Ntau(i)).Foto_h / 2)
 rectang(2).X = wmargin + 500 + orix / Printer.TwipsPerPixelX + Ltm * dx + Trees(Ntau(i)).Foto_h / 2
 rectang(2).Y = ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX + Ltm * dy - Trees(Ntau(i)).Foto_h / 2)
 Printer.FillStyle = 0
 apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
 
 Printer.FontSize = 6
 Printer.FontBold = True
 apustring = Trees(Ntau(i)).Num & "," & CStr(Format$(Bussol, "#"))
 apu = TextOut(ByVal apu1, ByVal rectang(0).X + 15, ByVal rectang(0).Y - 8, ByVal apustring, ByVal 30)
 
 
 
 
 Printer.DrawWidth = 3
 
 Rem Draw a cross to mark the tree pf Interest
 apu = MoveToEx(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX)), lpPoint)
 apu = LineTo(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX + 100), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX)))
 apu = MoveToEx(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX)), lpPoint)
 apu = LineTo(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX - 100), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX)))
 apu = MoveToEx(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX)), lpPoint)
 apu = LineTo(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX) + 100))
 apu = MoveToEx(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX)), lpPoint)
 apu = LineTo(ByVal apu1, ByVal CLng(wmargin + 500 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX) - 100))

' apu = LineTo(ByVal apu1, ByVal CLng((rectang(0).x + rectang(2).x) / 2), ByVal CLng(CLng((rectang(0).y + rectang(2).y) / 2)))


Next i

 Printer.FontSize = 12
 apustring = " SP: " & Trees(l).spec
 apu = TextOut(ByVal apu1, ByVal CLng(wmargin + 1600 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 1800 - (hmargin + oriY / Printer.TwipsPerPixelX) - 100), ByVal apustring, ByVal 30)
 apustring = " H: " & CStr(Format$(Trees(l).Foto_h, "#.0")) & " m"
 apu = TextOut(ByVal apu1, ByVal CLng(wmargin + 1600 + orix / Printer.TwipsPerPixelX), ByVal CLng(ymax + 2000 - (hmargin + oriY / Printer.TwipsPerPixelX) - 100), ByVal apustring, ByVal 30)

End Sub
Public Function getheight(ByRef X As Double, Y As Double) As Double

Dim row As Integer, col As Integer

 col = CInt((X - Zmodel.xllcorner) / Zmodel.CellSize)
 row = -Int((Zmodel.yllcorner - Y) / Zmodel.CellSize)
 
 If col < 0 Or col > Zmodel.ncols - 1 Or row < 0 Or row > Zmodel.nrows - 1 Then
  MsgBox ("Point falls outside Zmodel!")
  getheight = 0#
  Exit Function
 End If
 getheight = ZfXY(col, row)
 Exit Function
End Function
