VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Ohjelma puukartan ja numerolappujen tulostamiseen"
   ClientHeight    =   6405
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   9060
   LinkTopic       =   "Form1"
   ScaleHeight     =   6405
   ScaleWidth      =   9060
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   120
      Top             =   4200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu Tiedosto 
      Caption         =   "Tiedosto"
      Begin VB.Menu Avaa_DTM 
         Caption         =   "Avaa DTM-tiedosto"
      End
      Begin VB.Menu Avaa_Ja_Piirra_PDF 
         Caption         =   "Avaa puutiedosto PDF-karttaa varten"
      End
      Begin VB.Menu Numerolaput 
         Caption         =   "Avaa puutiedosto PDF numerolappujen tekoon"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Avaa_DTM_Click()

Dim i As Integer, j As Integer
Close (1)
    CommonDialog1.DialogTitle = "Header file for a height model"
    CommonDialog1.Filter = "HDR files (*.hdr)|*.hdr"
    CommonDialog1.Action = 1
    DemFileName = CommonDialog1.FileName
    Open DemFileName For Input As 1

Form1.MousePointer = 11
DoEvents

Form1.Caption = CommonDialog1.FileName
Input #1, Zmodel.ncols
Input #1, Zmodel.nrows
Input #1, Zmodel.xllcorner
Input #1, Zmodel.yllcorner
Input #1, Zmodel.CellSize
Input #1, Zmodel.nodata_value
Input #1, Zmodel.filepath

Close (1)

ReDim ZfXY(0 To Zmodel.ncols - 1, 0 To Zmodel.nrows - 1) As Single
ReDim row(0 To Zmodel.ncols - 1) As Single

Dim place As Long

Open Zmodel.filepath For Binary As 1
For i = 0 To Zmodel.nrows - 1
 place = 1 + (i * (Zmodel.ncols)) * 4
  Get #1, place, row()
  For j = 0 To Zmodel.ncols - 1
   ZfXY(j, i) = CSng(row(j)) + 0.18
  Next j
 Next i
 Close (1)
Form1.Caption = " DEM read succesfully"
Form1.MousePointer = 1
DoEvents
Exit Sub

End Sub

Private Sub Avaa_Ja_Piirra_PDF_Click()

Dim nlabel As Integer, ntree As Integer, track As Integer, spec As Integer
Dim state As Integer, X As Double, Y As Double, z As Double
Dim D As Double, H As Double
Dim stumps As Boolean
ReDim Plots(1 To 224) As Plot_info

CommonDialog1.Filter = "Field plot data files (*.*)|*.*"
CommonDialog1.DialogTitle = "##.txt puutiedosto"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1
Dim Cfilename As String

Cfilename = CommonDialog1.FileName
Input #1, plot, ntree, spec, dummy, X, Y, z, dummy, D, dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy
Close (1)

Rem the plot locations
Open "c:\data\regression_results.txt" For Input As 1
For i = 1 To 224
 Input #1, Plots(i).Num, Plots(i).X, Plots(i).Y, Plots(i).Vol_Lidar, Plots(i).G, Plots(i).N, Plots(i).H, Plots(i).D
Next i
Close (1)

Rem Plot center is plots(plot).x, and plots(plot).y
Dim x_test As Double, Y_test As Double
Dim Z_min As Double, Z_max As Double
Z_min = 200
Z_max = 0
 For x_test = Plots(plot).X - 25 To Plots(plot).X + 25 Step 1
  For Y_test = Plots(plot).Y - 25 To Plots(plot).Y + 25 Step 1
    zmaa = getheight(x_test, Y_test)
    If zmaa < Z_min Then Z_min = zmaa
    If zmaa > Z_max Then Z_max = zmaa
  Next Y_test
 Next x_test

stumps = False
Rem Drawing the stem Map, retrieve Printer metrics

apu = Printer.Height
apu = Printer.ScaleTop
apu = Printer.ScaleLeft
apu = Printer.ScaleWidth
apu = Printer.ScaleHeight
apu = Printer.ScaleMode
apu = Printer.TwipsPerPixelX
apu = Printer.TwipsPerPixelY
apu = Printer.CurrentX
apu = Printer.CurrentY
apu = Printer.Width


Rem Variables determinig position and scale
hmargin = Printer.ScaleHeight / 50
wmargin = Printer.ScaleWidth / 50 + 2300
Ltm = 80 ' Scale Unit factor
ymax = (Printer.ScaleHeight / Printer.TwipsPerPixelX) * 0.55

Printer.Circle (10000, 14500), 10
Rem Get the device context
Dim apu1 As Long
apu1 = CLng(Printer.hdc)
Printer.DrawMode = 13
Printer.ForeColor = RGB(0, 0, 0)
Printer.DrawStyle = 0
Printer.FillStyle = 1
Printer.FontName = Arial
Printer.FontSize = 8

Rem Read JETColorMAP
ReDim ColorMap(1 To 64, 1 To 3) As Byte
Dim l As Long
l = 0
Open "C:\data\JetColorMAP.csv" For Input As 2
Do Until EOF(2)
l = l + 1
Input #2, ColorMap(l, 1), ColorMap(l, 2), ColorMap(l, 3)
Loop
Close (2)

Rem Draw DEM
Printer.DrawWidth = 5
Printer.DrawStyle = 5
MinDTM = Z_min
MaxDTM = Z_max
D = 1
Rem get min & max
 For x_test = Plots(plot).X - 25 To Plots(plot).X + 25 Step 1
  For Y_test = Plots(plot).Y - 25 To Plots(plot).Y + 25 Step 1
    z = getheight(x_test, Y_test)
    X = x_test - Plots(plot).X
    Y = Y_test - Plots(plot).Y
    apu_z = 255 - (255 - (z - MinDTM) * 255 / (MaxDTM - MinDTM)) ' DTM
    apu_z = apu_z / 4
    If apu_z < 1 Then apu_z = 1
    If apu_z > 64 Then apu_z = 64
    Printer.ForeColor = RGB(255, 0, 0)
    Printer.FillColor = RGB(ColorMap(apu_z, 1), ColorMap(apu_z, 2), ColorMap(apu_z, 3))
    rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
    rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
    Printer.FillStyle = 0
    apu = rectangle(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
    Printer.FillStyle = 1
  Next Y_test
Next x_test
Close (2)

Rem Draw a 11.28 m circle o
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.DrawWidth = 4
  Printer.FillStyle = 1
  Printer.DrawStyle = 0
  rectang(0).X = wmargin + Ltm * 0 - Ltm * (11.28):  rectang(0).Y = ymax - (hmargin + Ltm * 0 + Ltm * (11.28))
  rectang(2).X = wmargin + Ltm * 0 + Ltm * (11.28):  rectang(2).Y = ymax - (hmargin + Ltm * 0 - Ltm * (11.28))
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1


Printer.DrawStyle = 0
Printer.DrawWidth = 2
Printer.ForeColor = RGB(0, 0, 0)
Printer.FillColor = RGB(0, 0, 0)

Rem ************
Rem Drawing trees
drawtrees:
N = 0
Open Cfilename For Input As 1
Nin = 0
Dsum = 0

Do Until EOF(1)
 ' Input #1, dummy.plot, Trees(n).num, Trees(n).spec, Trees(n).Pos.x, Trees(n).Pos.y, Trees(n).Pos.z, Trees(n).z_dtm, Trees(n).Foto_h, Trees(n).Lidar_h, Trees(n).Dcrm_Foto, Trees(n).Dcrm_Lidar, Trees(n).Dcrm_RMSE, Trees(n).cf, Trees(n).pw, Trees(n).cont, Trees(n).Dist_Cent, Trees(n).Bussol, Trees(n).inside
 Input #1, dummy, ntree, spec, X, Y, z, dummy, D, dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, dummy, inside
 If inside = 1 Then
  Nin = Nin + inside
  Dsum = Dsum + D
 End If
 
 X = X - Plots(plot).X
 Y = Y - Plots(plot).Y
 D = D / 100 + 0.1 ' for visibility add .05 units
 Dim ncount As Long
 If ntree < 10 Then
  ncount = 1
 End If
 If ntree >= 10 And ntree < 100 Then
  ncount = 2
 End If
 If ntree >= 100 And ntree < 1000 Then
  ncount = 3
 End If
 If ntree >= 1000 Then
  ncount = 4
 End If
 lpstring = CStr(ntree)
 shift = 50

 If spec > 20 Then spec = 20
 Select Case spec
 Case 1 ' Pine, draw a box (rectangle)
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(255, 0, 0)
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  Printer.FillStyle = 0
  apu = rectangle(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  
  
 Case 2 ' spruce, draw a triangle
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(33, 178, 4)
  triangle(0).X = wmargin + Ltm * X - Ltm * (D):  triangle(0).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  triangle(1).X = wmargin + Ltm * X:   triangle(1).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  triangle(2).X = wmargin + Ltm * X + Ltm * (D):  triangle(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))

  Printer.FillStyle = 0
  apu = Polygon(ByVal apu1, triangle(0), CLng(3))
  Printer.FillStyle = 1
 
 Case 3 ' broadleaved
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(5, 46, 255)
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  Printer.FillStyle = 0
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  
 Case 4 ' dead tree
 
 l = spec
 Printer.FillStyle = 0
 Printer.ForeColor = RGB(0, 0, 0)
 rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D / 2))
 rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D / 2))
 apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
 rectang(0).X = wmargin + Ltm * X - Ltm * (D / 2): rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
 rectang(2).X = wmargin + Ltm * X + Ltm * (D / 2): rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
 apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
 Printer.FillStyle = 1
 End Select

Printer.ForeColor = RGB(0, 0, 0)
Printer.FillColor = RGB(0, 0, 0)

If spec = 4 Then
 Printer.FontUnderline = True
 apu = TextOut(ByVal apu1, ByVal wmargin + Ltm * X, ByVal ymax - (hmargin + Ltm * Y) + Ltm * 1.2 * D, ByVal lpstring, ByVal ncount)
 N = N + 1
 Printer.FontUnderline = False
 End If
 'If stumps = False And state = 11 Then
 apu = TextOut(ByVal apu1, ByVal wmargin + Ltm * X, ByVal ymax - (hmargin + Ltm * Y) + Ltm * 1.2 * D, ByVal lpstring, ByVal ncount)
 N = N + 1
 'End If
Loop

Rem *******************
Rem Labeling Section
Dim Box_X
Dim Box_Y
Box_X = 300
Box_Y = 800
Dim apustring As String * 80
Printer.FontSize = 12
apustring = "MARV4/2 2007 TreeMap " & Date & " (c) Ilkka Korpela"
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 600, ByVal apustring, ByVal ncount)
apustring = "Plot number: " & CStr(plot) & " with " & Nin & " trees inside. Mean height: " & Format$(Dsum / Nin, "0.0") & " m"
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 450, ByVal apustring, ByVal ncount)
apustring = "2004 Lidar-based VOL: " & Format$(Plots(plot).Vol_Lidar, "0.0") & " m3/ha and HGM: " & Format$(Plots(plot).H, "0.0") & " m"
' Plots(i).X , Plots(i).Y, Plots(i).Vol_Lidar, Plots(i).G, Plots(i).N, Plots(i).H, Plots(i).D
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 300, ByVal apustring, ByVal ncount)
apustring = "Plot coordinates: (" & Format$(Plots(plot).X, "0") & "," & Format$(Plots(plot).Y, "0") & ")  with DTM-range: " & Format$(Z_min, "0.0") & " m to " & Format$(Z_max, "0.0") & " m"
' Plots(i).X , Plots(i).Y, Plots(i).Vol_Lidar, Plots(i).G, Plots(i).N, Plots(i).H, Plots(i).D
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 150, ByVal apustring, ByVal ncount)

Printer.FontSize = 24
apustring = CStr(plot)
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 4000, ByVal Box_Y - 600, ByVal apustring, ByVal ncount)
Printer.FontSize = 12
 
 
 
 
Box_X = 300 + 100

 Printer.DrawWidth = 2
 For k = 1 To 6
 D = 0.5
 Select Case k
 Case 1 ' Pine, draw a box (rectangle)
  rectang(0).X = Box_X - Ltm * (D):   rectang(0).Y = Box_Y + 50 + Ltm * (D)
  rectang(2).X = Box_X + Ltm * (D):  rectang(2).Y = Box_Y + 50 - Ltm * (D)
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(255, 0, 0)
  Printer.FillColor = RGB(255, 0, 0)
  apu = rectangle(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  apustring = "Pine"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 25, ByVal apustring, ByVal 30)
  
 Case 2 ' spruce, draw a triangle
  triangle(0).X = Box_X - Ltm * (D):   triangle(0).Y = Box_Y + 200 + Ltm * (D)
  triangle(1).X = Box_X:   triangle(1).Y = Box_Y + 200 - Ltm * (D)
  triangle(2).X = Box_X + Ltm * (D):  triangle(2).Y = Box_Y + 200 + Ltm * (D)
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(33, 178, 4)
  Printer.FillColor = RGB(33, 178, 4)
  
  apu = Polygon(ByVal apu1, triangle(0), CLng(3))
  Printer.FillStyle = 1
  apustring = "Spruce"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 150, ByVal apustring, ByVal 30)
 
 Case 3 ' silver birch, draw a circle (black)
  rectang(0).X = Box_X - Ltm * (D):  rectang(0).Y = Box_Y + 350 + Ltm * (D)
  rectang(2).X = Box_X + Ltm * (D):  rectang(2).Y = Box_Y + 350 - Ltm * (D)
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(43, 1, 225)
  Printer.FillColor = RGB(43, 1, 225)
  Printer.ForeColor = RGB(5, 46, 255)
  Printer.FillColor = RGB(5, 46, 255)
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  apustring = "Broadleaved"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 300, ByVal apustring, ByVal 30)
  
 Case 4 ' Dead
 l = spec
 Printer.FillStyle = 0
 Printer.ForeColor = RGB(0, 0, 0)
 Printer.FillColor = RGB(0, 0, 0)
 rectang(0).X = Box_X - Ltm * (D):  rectang(0).Y = Box_Y + 500 + Ltm * (D / 2)
 rectang(2).X = Box_X + Ltm * (D):  rectang(2).Y = Box_Y + 500 - Ltm * (D / 2)
 apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
 rectang(0).X = Box_X - Ltm * (D / 2): rectang(0).Y = Box_Y + 500 + Ltm * (D)
 rectang(2).X = Box_X + Ltm * (D / 2): rectang(2).Y = Box_Y + 500 - Ltm * (D)
 apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
 Printer.FillStyle = 1
 apustring = "Dead trees"
 Printer.ForeColor = RGB(0, 0, 0)
 apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 450, ByVal apustring, ByVal 30)
 
 End Select
Next k

 apustring = "Kelot alleviivattu"
 Printer.FontUnderline = True
 'apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 325, ByVal apustring, ByVal 18)
 Printer.FontUnderline = False

Printer.EndDoc
'MsgBox ("Puita oli " & N)
Close (1)
End Sub



Private Sub Numerolaput_Click()

On Error GoTo VirheTilanne
CommonDialog1.Filter = "Field plot data files (*.txt)|*.txt"
CommonDialog1.DialogTitle = "File which has Plot data!"
CommonDialog1.Action = 1
Open CommonDialog1.FileName For Input As 1

Rem Allocate storage for 2000 tree-observations
ReDim Trees(1 To 3000) As Tree

Rem Read trees in memory
Dim N As Long
N = 1
Do Until EOF(1)
 Input #1, Trees(N).plot, Trees(N).Num, Trees(N).spec, Trees(N).Pos.X, Trees(N).Pos.Y, Trees(N).Pos.z, Trees(N).z_dtm, Trees(N).Foto_h, Trees(N).Lidar_h, Trees(N).Dcrm_Foto, Trees(N).Dcrm_Lidar, Trees(N).Dcrm_RMSE, Trees(N).cf, Trees(N).pw, Trees(N).cont, Trees(N).Dist_Cent, Trees(N).Bussol, Trees(N).inside
 If Trees(N).inside = 1 Then Trees(N).Label = True
 N = N + 1
Loop
Rem Allocate memory for the trees we have
ReDim Preserve Trees(1 To N) As Tree
Close (1)

Rem **********************************************
Rem Printing section
Rem Choose parameter below for the whole area
Dim ymax As Long
hmargin = 10
wmargin = 10
Ltm = 19 ' Scale Unit factor

ymax = CLng(Printer.ScaleHeight / Printer.TwipsPerPixelX)
Rem Define printable area on printer
Pheight = Printer.ScaleHeight
Pwidth = Printer.ScaleWidth
Rem One printer coordinate unit equals in meters (2.5 cm ?)
If Pheight >= Pwidth Then
 Maxdim = Pwidth
 Else
 Maxdim = Pheight
End If

Printer.Circle (1000, 1000), 10
Rem Get the device context
Dim apu1 As Long
apu1 = CLng(Printer.hdc)
Printer.DrawMode = 13
Printer.ForeColor = RGB(0, 0, 0)
Printer.DrawStyle = 0
Printer.FillStyle = 1
Printer.FontName = Arial
Printer.FontSize = 5

Rem Split paper (A4) into 6 labels, with origins at corn(1 to 6)
ReDim corn(1 To 12) As Point2DLong
corn(1).X = 0: corn(2).X = Printer.ScaleWidth / 2: corn(3).X = Printer.ScaleWidth
corn(4).X = 0: corn(5).X = Printer.ScaleWidth / 2: corn(6).X = Printer.ScaleWidth
corn(7).X = 0: corn(8).X = Printer.ScaleWidth / 2: corn(9).X = Printer.ScaleWidth
corn(10).X = 0: corn(11).X = Printer.ScaleWidth / 2: corn(12).X = Printer.ScaleWidth
corn(1).Y = 0: corn(2).Y = 0: corn(3).Y = 0
corn(4).Y = Printer.ScaleHeight * 0.33: corn(5).Y = Printer.ScaleHeight * 0.33: corn(6).Y = Printer.ScaleHeight * 0.33
corn(7).Y = Printer.ScaleHeight * 0.67: corn(8).Y = Printer.ScaleHeight * 0.67: corn(9).Y = Printer.ScaleHeight * 0.67
corn(10).Y = Printer.ScaleHeight: corn(11).Y = Printer.ScaleHeight: corn(12).Y = Printer.ScaleHeight

Dim apustring As String * 60
Rem draw lines between labels

Rem Start processing
Dim orix As Long, oriY As Long, k As Long, sheets As Long
ReDim Ntau(1 To 200) As Long

sheets = 0
m = 0
Dim l As Long
Dim M_in As Long
M_in = 0
For l = 1 To N
 If Trees(l).Label = True Then
  M_in = M_in + 1
  m = m + 1
  Select Case m
  Case 1
  orix = corn(10).X: oriY = corn(10).Y
  Case 2
  orix = corn(11).X: oriY = corn(11).Y
  Case 3
  orix = corn(7).X: oriY = corn(7).Y
  Case 4
  orix = corn(8).X: oriY = corn(8).Y
  Case 5
  orix = corn(4).X: oriY = corn(4).Y
  Case 6
  orix = corn(5).X: oriY = corn(5).Y
  End Select
  Call FindNeighbors(l, k, Ntau())
  Rem For trees l there are k neighbors with indeces in Ntau
  Call DrawNumber(apu1, M_in, l, orix, oriY, hmargin, wmargin, ymax)
  Call DrawNeighbors(l, k, Ntau(), apu1, wmargin, hmargin, orix, oriY, ymax)
  If m = 6 Then
    m = 0
    sheets = sheets + 1
    Call DrawLines(apu1, corn(), hmargin, wmargin, ymax)
    Printer.NewPage
  End If
 End If
Next l

done:

Call DrawLines(apu1, corn(), hmargin, wmargin, ymax)

Printer.EndDoc
 
 
 
Exit Sub
VirheTilanne:
MsgBox ("Tapahtui virhe, an error occurred, closing all files, try again")
Close (1)

End Sub
